﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Linq;
using System.Configuration;
using System.Data.SqlClient;
using CrystalDecisions.CrystalReports.Engine;

public partial class CS : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!this.IsPostBack)
        {
            this.BindReport();
        }
    }

    private void BindReport()
    {
        string query = "SELECT TOP 5 ";
        bool isSelected = chkColumns.Items.Cast<ListItem>().Count(i => i.Selected == true) > 0;
        if (!isSelected)
        {
            chkColumns.Items[0].Selected = true;
        }
        foreach (ListItem item in chkColumns.Items)
        {
            if (item.Selected)
            {
                query += item.Value + ",";
                isSelected = true;
            }
        }
        query = query.Substring(0, query.Length - 1);
        query += " FROM Customers";
        ReportDocument crystalReport = new ReportDocument();
        CrystalReportViewer1.DisplayGroupTree = false;
        crystalReport.Load(Server.MapPath("~/CustomerReport.rpt"));
        Customers dsCustomers = GetData(query, crystalReport);
        crystalReport.SetDataSource(dsCustomers);
        CrystalReportViewer1.ReportSource = crystalReport;
    }

    private Customers GetData(string query, ReportDocument crystalReport)
    {
        string conString = ConfigurationManager.ConnectionStrings["constr"].ConnectionString;
        SqlCommand cmd = new SqlCommand(query);
        using (SqlConnection con = new SqlConnection(conString))
        {
            Customers dsCustomers = new Customers();
            cmd.Connection = con;
            con.Open();
            using (SqlDataReader sdr = cmd.ExecuteReader())
            {
                //Get the List of all TextObjects in Section2.
                List<TextObject> textObjects = crystalReport.ReportDefinition.Sections["Section2"].ReportObjects.OfType<TextObject>().ToList();
                for (int i = 0; i < textObjects.Count; i++)
                {
                    //Set the name of Column in TextObject.
                    textObjects[i].Text = string.Empty;
                    if (sdr.FieldCount > i)
                    {
                        textObjects[i].Text = sdr.GetName(i);
                    }
                }
                //Load all the data rows in the Dataset.
                while (sdr.Read())
                {
                    DataRow dr = dsCustomers.Tables[0].Rows.Add();
                    for (int i = 0; i < sdr.FieldCount; i++)
                    {
                        dr[i] = sdr[i];
                    }
                }
            }
            con.Close();
            return dsCustomers;
        }
    }

    protected void Columns_Changed(object sender, EventArgs e)
    {
        this.BindReport();
    }
}